<?php

namespace App\Repositories\V2;

use App\Models\CmsSubject;
use App\Models\CmsContentTemplate;
use App\Models\CmsContentTemplateSet;
use App\Models\CmsSubjectProduct;

class CmsContentTemplateSetRepository {
    public function __construct(CmsContentTemplateSet $cmsContentTemplateSet,CmsContentTemplate $cmsContentTemplate,CmsSubjectProduct $cmsSubjectProduct,CmsSubject $cmsSubject) {

        $this->cmsContentTemplateSet = $cmsContentTemplateSet;
        $this->cmsContentTemplate = $cmsContentTemplate;
        $this->cmsSubjectProduct = $cmsSubjectProduct;
        $this->cmsSubject = $cmsSubject;
    }

    //banner模板选专题-被使用计数
    public function countSubject($request)
    {
        if ($request['type'] == 0){
            if ($request['rule']['link_type'] == 1){
                $templates = $this->cmsSubject->where('id',intval($request['rule']['link_url']))->first();
                $templates->used_count +=1;
                $templates->save();
            }
        }else{
            $subject_id_array = json_decode($request['old_rule'],true);
            if ($subject_id_array['link_type'] == 1 && $request['rule']['link_type'] == 1){//链接方式都为专题
                if ($subject_id_array['link_url'] != $request['rule']['link_url']){
                    $templates = $this->cmsSubject->where('id',intval($subject_id_array['link_url']))->first();
                    $update_template = [
                        $templates->used_count -=1
                    ];
                    $templates->update($update_template);

                    $templates = $this->cmsSubject->where('id',intval($request['rule']['link_url']))->first();
                    $templates->used_count +=1;
                    $templates->save();
                }
            }elseif ($subject_id_array['link_type'] == 1 && $request['rule']['link_type'] != 1){
                $templates = $this->cmsSubject->where('id',intval($subject_id_array['link_url']))->first();
                $update_template = [
                    $templates->used_count -=1
                ];
                $templates->update($update_template);
            }elseif ($subject_id_array['link_type'] != 1 && $request['rule']['link_type'] == 1){
                $templates = $this->cmsSubject->where('id',intval($request['rule']['link_url']))->first();
                $templates->used_count +=1;
                $templates->save();
            }
        }

    }
}