<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019-06-12
 * Time: 10:45
 */

namespace App\Transformers;
use App\Models\VideoGroup;
use League\Fractal\TransformerAbstract;


class DetailVideoGroupTansformer extends TransformerAbstract{
    public function transform(VideoGroup $videoGroup)
    {
        $video = $this->getVideoInfoList();
        return [
            'id' => $videoGroup['id'],
            'name' => $videoGroup['name'],
            'created_at' => Carbon::parse($videoGroup['created_at'])->toDateTimeString(),
            'video_list'=>$video
        ];
    }
    public function getVideoInfoList(VideoGroup $videoGroup){
        $video = [];
        foreach ($videoGroup->vgi as $key=>$value){
            $video[] = $value;
        }
        return $video;
    }
}